<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WrittenConfInstType StructType
 * @package Dg
 * @subpackage Structs
 */
class DgWrittenConfInstType extends AbstractStructBase
{
    /**
     * The SupplementalData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgParagraphType
     */
    public $SupplementalData;
    /**
     * The Email
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgEmailType
     */
    public $Email;
    /**
     * The LanguageID
     * @var string
     */
    public $LanguageID;
    /**
     * The AddresseeName
     * @var string
     */
    public $AddresseeName;
    /**
     * The Address
     * @var string
     */
    public $Address;
    /**
     * The Telephone
     * @var string
     */
    public $Telephone;
    /**
     * The ConfirmInd
     * @var bool
     */
    public $ConfirmInd;
    /**
     * Constructor method for WrittenConfInstType
     * @uses DgWrittenConfInstType::setSupplementalData()
     * @uses DgWrittenConfInstType::setEmail()
     * @uses DgWrittenConfInstType::setLanguageID()
     * @uses DgWrittenConfInstType::setAddresseeName()
     * @uses DgWrittenConfInstType::setAddress()
     * @uses DgWrittenConfInstType::setTelephone()
     * @uses DgWrittenConfInstType::setConfirmInd()
     * @param \dgsoft\StructType\DgParagraphType $supplementalData
     * @param \dgsoft\StructType\DgEmailType $email
     * @param string $languageID
     * @param string $addresseeName
     * @param string $address
     * @param string $telephone
     * @param bool $confirmInd
     */
    public function __construct(\dgsoft\StructType\DgParagraphType $supplementalData = null, \dgsoft\StructType\DgEmailType $email = null, $languageID = null, $addresseeName = null, $address = null, $telephone = null, $confirmInd = null)
    {
        $this
            ->setSupplementalData($supplementalData)
            ->setEmail($email)
            ->setLanguageID($languageID)
            ->setAddresseeName($addresseeName)
            ->setAddress($address)
            ->setTelephone($telephone)
            ->setConfirmInd($confirmInd);
    }
    /**
     * Get SupplementalData value
     * @return \dgsoft\StructType\DgParagraphType|null
     */
    public function getSupplementalData()
    {
        return $this->SupplementalData;
    }
    /**
     * Set SupplementalData value
     * @param \dgsoft\StructType\DgParagraphType $supplementalData
     * @return \dgsoft\StructType\DgWrittenConfInstType
     */
    public function setSupplementalData(\dgsoft\StructType\DgParagraphType $supplementalData = null)
    {
        $this->SupplementalData = $supplementalData;
        return $this;
    }
    /**
     * Get Email value
     * @return \dgsoft\StructType\DgEmailType|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param \dgsoft\StructType\DgEmailType $email
     * @return \dgsoft\StructType\DgWrittenConfInstType
     */
    public function setEmail(\dgsoft\StructType\DgEmailType $email = null)
    {
        $this->Email = $email;
        return $this;
    }
    /**
     * Get LanguageID value
     * @return string|null
     */
    public function getLanguageID()
    {
        return $this->LanguageID;
    }
    /**
     * Set LanguageID value
     * @param string $languageID
     * @return \dgsoft\StructType\DgWrittenConfInstType
     */
    public function setLanguageID($languageID = null)
    {
        // validation for constraint: string
        if (!is_null($languageID) && !is_string($languageID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($languageID)), __LINE__);
        }
        $this->LanguageID = $languageID;
        return $this;
    }
    /**
     * Get AddresseeName value
     * @return string|null
     */
    public function getAddresseeName()
    {
        return $this->AddresseeName;
    }
    /**
     * Set AddresseeName value
     * @param string $addresseeName
     * @return \dgsoft\StructType\DgWrittenConfInstType
     */
    public function setAddresseeName($addresseeName = null)
    {
        // validation for constraint: string
        if (!is_null($addresseeName) && !is_string($addresseeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addresseeName)), __LINE__);
        }
        $this->AddresseeName = $addresseeName;
        return $this;
    }
    /**
     * Get Address value
     * @return string|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param string $address
     * @return \dgsoft\StructType\DgWrittenConfInstType
     */
    public function setAddress($address = null)
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($address)), __LINE__);
        }
        $this->Address = $address;
        return $this;
    }
    /**
     * Get Telephone value
     * @return string|null
     */
    public function getTelephone()
    {
        return $this->Telephone;
    }
    /**
     * Set Telephone value
     * @param string $telephone
     * @return \dgsoft\StructType\DgWrittenConfInstType
     */
    public function setTelephone($telephone = null)
    {
        // validation for constraint: string
        if (!is_null($telephone) && !is_string($telephone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($telephone)), __LINE__);
        }
        $this->Telephone = $telephone;
        return $this;
    }
    /**
     * Get ConfirmInd value
     * @return bool|null
     */
    public function getConfirmInd()
    {
        return $this->ConfirmInd;
    }
    /**
     * Set ConfirmInd value
     * @param bool $confirmInd
     * @return \dgsoft\StructType\DgWrittenConfInstType
     */
    public function setConfirmInd($confirmInd = null)
    {
        // validation for constraint: boolean
        if (!is_null($confirmInd) && !is_bool($confirmInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($confirmInd)), __LINE__);
        }
        $this->ConfirmInd = $confirmInd;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgWrittenConfInstType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
